(function() {

    openerp.widgetInstanceInterestPartner = null;
    openerp.parentInstanceInterestPartner = {};
    var QWeb = openerp.web.qweb;
    var instanceWeb = openerp.web;
    openerp.VerifyInterestPartner = openerp.Widget.extend({
        id: undefined,
        buttons: undefined,
        /* init */
        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },
        /* Check state*/
        checkState: function(id) {
            var self = this;
            self.id = id;
            if (self.id)
                self.fetchInitial();
        },
        /* Reload Page*/
        reloadPage: function() {
            openerp.parentInstanceInterestPartner.reload();
        },
        // /* Método inicial  */
        fetchInitial: function() {
            var self = this;
            self.verifyInterestPartner(self.id).then(function(results) {
                return results;
            }).then(function(results) {
                instanceWeb.notification.do_warn("Atencion",results.message);
                return self.reloadPage();
            });
        },
        /* Verificar  interest */
        verifyInterestPartner: function(id) {
            var bankStatement = new instanceWeb.Model('res.partner');
            return bankStatement.call('eiru_account_interest_verify_partner',[id],{
                context: new instanceWeb.CompoundContext()
            });
        },
    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'res.partner')
                    return;

                openerp.parentInstanceInterestPartner = this;

                if (openerp.widgetInstanceInterestPartner) {
                    if (openerp.widgetInstanceInterestPartner.id === record.id){
                        openerp.widgetInstanceInterestPartner.id = undefined;
                        return;
                    }
                    
                    openerp.widgetInstanceInterestPartner.checkState(record.id);
                    return;
                }

                openerp.widgetInstanceInterestPartner = new openerp.VerifyInterestPartner(this);
                openerp.widgetInstanceInterestPartner.checkState(record.id);
            }
        });
    }
})();
